PROGRAM permutations;

  USES crt;

  TYPE str = STRING [80];

  VAR list : str;
      max  : integer;

  PROCEDURE outline (s : str);
    VAR i : integer;
  BEGIN
    FOR i := 1 TO max DO
      write (s [i]:5);
    writeln;
  END;

  PROCEDURE rotate (VAR _rlist : str; _len : integer);
    VAR i : integer;
        c : char;
  BEGIN
    c := _rlist [1];
    FOR i := 1 TO _len DO
      _rlist [i] := _rlist [i + 1];
    _rlist [_len] := c;
  END;

  PROCEDURE permute (VAR result : str; len : integer);
    VAR i : integer;
  BEGIN
    IF (len <= 1) THEN
    BEGIN
      outline (result);
    END
    ELSE
      FOR i := 1 TO len DO
      BEGIN
        rotate (result,len);
        permute (result,len - 1);
      END;
  END;

BEGIN
  clrscr;
  list := '1234';
  max := length (list);
  permute (list,max);
  repeat until keypressed;
END.